osg::LineSegment Class Reference

`#include <LineSegment>`

Inheritance diagram for osg::LineSegment:

## Public Types

typedef Vec3d | vec_type
typedef vec_type::value_type | value_type

## Public Member Functions

| LineSegment ()
| LineSegment (const LineSegment &seg)
| LineSegment (const vec_type &s, const vec_type &e)
LineSegment & | operator= (const LineSegment &seg)
void | set (const vec_type &s, const vec_type &e)
vec_type & | start ()
const vec_type & | start () const
vec_type & | end ()
const vec_type & | end () const
bool | valid () const
bool | intersect (const BoundingBox &bb) const
bool | intersectAndComputeRatios (const BoundingBox &bb, float &ratioFromStartToEnd1, float &ratioFromStartToEnd2) const
bool | intersectAndComputeRatios (const BoundingBox &bb, double &ratioFromStartToEnd1, double &ratioFromStartToEnd2) const
bool | intersect (const BoundingSphere &bs) const
bool | intersectAndComputeRatios (const BoundingSphere &bs, float &ratioFromStartToEnd1, float &ratioFromStartToEnd2) const
bool | intersectAndComputeRatios (const BoundingSphere &bs, double &ratioFromStartToEnd1, double &ratioFromStartToEnd2) const
bool | intersect (const Vec3f &v1, const Vec3f &v2, const Vec3f &v3, float &ratioFromStartToEnd)
bool | intersect (const Vec3d &v1, const Vec3d &v2, const Vec3d &v3, double &ratioFromStartToEnd)
void | mult (const LineSegment &seg, const Matrix &m)
void | mult (const Matrix &m, const LineSegment &seg)
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~LineSegment ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Static Protected Member Functions

static bool | intersectAndClip (vec_type &s, vec_type &e, const BoundingBox &bb)

## Protected Attributes

vec_type | _s
vec_type | _e
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

LineSegment class for representing a line segment.

## Member Typedef Documentation

## value_type

typedef vec_type::value_type osg::LineSegment::value_type

## vec_type

typedef Vec3d osg::LineSegment::vec_type

## Constructor & Destructor Documentation

## LineSegment() [1/3]

osg::LineSegment::LineSegment | ( |  | ) |

inline

Referenced by LineSegment(), mult(), mult(), and operator=().

## LineSegment() [2/3]

osg::LineSegment::LineSegment | ( | const LineSegment & | seg | ) |

inline

References _e, _s, LineSegment(), and osg::Referenced::Referenced().

## LineSegment() [3/3]

osg::LineSegment::LineSegment | ( | const vec_type & | s,
|  | const vec_type & | e )

inline

References _e, and _s.

## ~LineSegment()

virtual osg::LineSegment::~LineSegment | ( |  | ) |

protected virtual

## Member Function Documentation

## end() [1/2]

vec_type & osg::LineSegment::end | ( |  | ) |

inline

References _e.

## end() [2/2]

const vec_type & osg::LineSegment::end | ( |  | ) | const

inline

References _e.

## intersect() [1/4]

bool osg::LineSegment::intersect | ( | const BoundingBox & | bb | ) | const

return true if segment intersects BoundingBox.

## intersect() [2/4]

bool osg::LineSegment::intersect | ( | const BoundingSphere & | bs | ) | const

return true if segment intersects BoundingSphere.

## intersect() [3/4]

bool osg::LineSegment::intersect | ( | const Vec3d & | v1,
|  | const Vec3d & | v2,
|  | const Vec3d & | v3,
|  | double & | ratioFromStartToEnd )

return true if segment intersects triangle and set double ratios where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## intersect() [4/4]

bool osg::LineSegment::intersect | ( | const Vec3f & | v1,
|  | const Vec3f & | v2,
|  | const Vec3f & | v3,
|  | float & | ratioFromStartToEnd )

return true if segment intersects triangle and set float ratios where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## intersectAndClip()

bool osg::LineSegment::intersectAndClip | ( | vec_type & | s,
|  | vec_type & | e,
|  | const BoundingBox & | bb )

static protected

## intersectAndComputeRatios() [1/4]

bool osg::LineSegment::intersectAndComputeRatios | ( | const BoundingBox & | bb,
|  | double & | ratioFromStartToEnd1,
|  | double & | ratioFromStartToEnd2 ) const

return true if segment intersects BoundingBox and set double ratios for the first and second intersections, where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## intersectAndComputeRatios() [2/4]

bool osg::LineSegment::intersectAndComputeRatios | ( | const BoundingBox & | bb,
|  | float & | ratioFromStartToEnd1,
|  | float & | ratioFromStartToEnd2 ) const

return true if segment intersects BoundingBox and set float ratios for the first and second intersections, where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## intersectAndComputeRatios() [3/4]

bool osg::LineSegment::intersectAndComputeRatios | ( | const BoundingSphere & | bs,
|  | double & | ratioFromStartToEnd1,
|  | double & | ratioFromStartToEnd2 ) const

return true if segment intersects BoundingSphere and set double ratios for the first and second intersections, where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## intersectAndComputeRatios() [4/4]

bool osg::LineSegment::intersectAndComputeRatios | ( | const BoundingSphere & | bs,
|  | float & | ratioFromStartToEnd1,
|  | float & | ratioFromStartToEnd2 ) const

return true if segment intersects BoundingSphere and set float ratios for the first and second intersections, where the ratio is 0.0 at the segment start point, and 1.0 at the segment end point.

## mult() [1/2]

void osg::LineSegment::mult | ( | const LineSegment & | seg,
|  | const Matrix & | m )

inline

post multiply a segment by matrix.

References _e, _s, and LineSegment().

## mult() [2/2]

void osg::LineSegment::mult | ( | const Matrix & | m,
|  | const LineSegment & | seg )

inline

pre multiply a segment by matrix.

References _e, _s, and LineSegment().

## operator=()

LineSegment & osg::LineSegment::operator= | ( | const LineSegment & | seg | ) |

inline

References _e, _s, and LineSegment().

## set()

void osg::LineSegment::set | ( | const vec_type & | s,
|  | const vec_type & | e )

inline

References _e, and _s.

## start() [1/2]

vec_type & osg::LineSegment::start | ( |  | ) |

inline

References _s.

## start() [2/2]

const vec_type & osg::LineSegment::start | ( |  | ) | const

inline

References _s.

## valid()

bool osg::LineSegment::valid | ( |  | ) | const

inline

References _e, and _s.

## Member Data Documentation

## _e

vec_type osg::LineSegment::_e

protected

Referenced by end(), end(), LineSegment(), LineSegment(), mult(), mult(), operator=(), set(), and valid().

## _s

vec_type osg::LineSegment::_s

protected

Referenced by LineSegment(), LineSegment(), mult(), mult(), operator=(), set(), start(), start(), and valid().

The documentation for this class was generated from the following file:

- LineSegment